/*
  Created: 03.19.05 11:15:21 by Attila Nagyidai

  $Id: C\040Header.h,v 1.1.2.1 2003/08/13 00:38:46 neum Exp $

  This file is part of IBSH (Iron Bars Shell) , a restricted Unix shell
  Copyright (C) 2005  Attila Nagyidai

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  Author: Attila Nagyidai
  Email:
  URL:
*/

#ifndef _IBSH_H
#define _IBSH_H

/* Insert Code here */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <syslog.h>
#include <fcntl.h>
#include <errno.h>
#include <dirent.h>
#include <pwd.h>
#include <grp.h>
#include <limits.h>
#include <glob.h>


#define PAM_SIZE    8
#define LINE_SIZE   80
#define STRING_SIZE 255
#define BUFFER_SIZE 4096
#define COMMANDS_LIST "/etc/ibsh.cmds"
#define EXTENSIONS_LIST "/etc/ibsh.xtns"
#define MAX_ITEMS   40

/* Typedefs, structs, globals */
typedef struct theuser {
    char uname[STRING_SIZE];
    uid_t uid;
    char udir[STRING_SIZE];
    struct passwd *record;
} theuser;

typedef char Strng[STRING_SIZE];

theuser loggedin; /* user info */
static Strng commands[MAX_ITEMS];  /* permitted commands */
static Strng extensions[MAX_ITEMS];  /* permitted extensions */
char real_path[STRING_SIZE];    /* absolute path */
char jail_path[STRING_SIZE];    /* path inside the jail */
char user_command[STRING_SIZE];   /* whatever the user types */
char filtered_command[STRING_SIZE]; /* this one will be executed */
int exitcode;

int DelBadFiles( const char *basedir );
int CommandOK( const char *thecommand, const char *rootdir,
const char *jailpath, char *newcommand );
void LTrim3( const char *base, char *result );
void GetPositionInJail( const char *abspath, const char *rootdir, char *relpath );
void LoadConfig( Strng *array1, Strng *array2 );
int HandleOptions(int argc, char *argv[]);
void Usage(char *programName);
void myscanf( char *vptr );
int  hhsystem(const char *kdozeile);
void PathMinusOne( const char *basepath, char *evalpath, int slashcount );

#endif /* _IBSH_H */
